<?php

namespace App\Service;

use App\Entity\Commentaire;
use App\Entity\Film;
use App\Entity\MediaVideo;
use Doctrine\ORM\Event\PostPersistEventArgs;
use Symfony\Component\Config\Definition\Exception\Exception;

class FilmCreationListener
{
    public function __construct(protected Mattermost $mattermostSender)
    {
    }

    public function postPersist(PostPersistEventArgs $args): void
    {
        $entity = $args->getObject();
        if (
            !$entity instanceof Film &&
            !$entity instanceof Commentaire &&
            !$entity instanceof MediaVideo
        )
        {
            return;
        }

        try {
            if ($entity instanceof Film)
                $this->mattermostSender->sendNouveauFilm($entity);
            elseif ($entity instanceof MediaVideo) {
                $this->mattermostSender->sendNewMediaVideo($entity->getFilm());
            } else {
                $this->mattermostSender->sendNouveauCommentaire($entity->getUser(), $entity->getFilm());
            }
        } catch (Exception $exception) {

        }
    }
}